#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define N150 150

int main(int argc, char *argv[]){
  int	lon_tl=80,  lat_tl=60;
  int	lon_br=200, lat_br=-60;
  float	lon_inc=0.04;
  float	lat_inc=0.04;

  FILE	*fp;
  char	outputfilename[N150];
  float	tmp_NX, tmp_NY;
  int	i, j, k, NX, NY, tmp_count, ch;
  unsigned short	*data_all, data;
  float	*dt, tmp_tbb1, tmp_tbb2, tmp_tbb3, tbb[3][256], tbb_10bit[3][1024];

  if(argc!=3){
     fprintf(stderr,"Usage: geoss2bt.c inputfilename1 ch\n");
     fprintf(stderr,"Usage: ch: 1: ir1  2: ir2  3: ir3\n");
     fprintf(stderr," e.g.: ./geoss2bt IMG_DK01IR1_200705010030.geoss\n");
     exit(1);
  }
  ch=atoi(argv[2]);
  tmp_NX=(lon_br-lon_tl)/lon_inc;  tmp_NY=(lat_tl-lat_br)/lat_inc;
  NX=(int)(tmp_NX);  NY=(int)(tmp_NY);
  data_all=(short*)malloc(2*NY*NX);
  dt=(float*)malloc(4*NY*NX);
  for(i=0;i<NY*NX;i++){
     data_all[i]=-999;
     dt[i]=-999.;
  }

  if((fp=fopen(argv[1],"r"))==NULL){
     fprintf(stderr,"*** input file (%s) cannot open ***\n",argv[1]);
     exit(1);
  }
  fread(data_all,sizeof(short),NY*NX,fp);
  fclose(fp);

  if((fp=fopen("tbbtable-FY2C.txt","r"))==NULL){
     fprintf(stderr,"*** TBB table (tbbtable.txt) cannot open ***\n");
     exit(1);
  }

  for(i=0;i<256;i++){
     fscanf(fp,"%d %f %f %f", &tmp_count, &tmp_tbb1, &tmp_tbb2, &tmp_tbb3);
     tbb[0][i]=tmp_tbb1;  tbb[1][i]=tmp_tbb2; tbb[2][i]=tmp_tbb3;
  }
  fclose(fp);

  for(i=0;i<3;i++){
     for(j=0;j<256-1;j++){
     for(k=0;k<4;k++){
	tbb_10bit[i][4*j+k]=tbb[i][j]-(tbb[i][j]-tbb[i][j+1])*k/4;
     }}
     for(k=0;k<4;k++){ tbb_10bit[i][4*255+k]=tbb[i][255]; }
  }


  for(i=0;i<NY;i++){
  for(j=0;j<NX;j++){
     if(data_all[NX*i+j]>=1023){ dt[NX*i+j]=-999.; }
     else{
	data=data_all[NX*i+j];
	dt[NX*i+j]=tbb_10bit[ch-1][data];
     }
  }}

  sprintf(outputfilename,"tbb_%s",argv[1]);
  fopen(outputfilename,"w");
  fwrite(dt,sizeof(float),NX*NY,fp);
  fclose(fp);

  free(data_all);  free(dt);
  return 0;
}
